data_dir=[pwd filesep 'training' filesep];
save_dif=[pwd filesep];

% %Add the function on this directory to the MATLAB path
% %This is not permanent. This change is only valid for this session of
% %MATLAB (will reset once MATLAB is restarted).
% addpath(pwd)
% 
% if(exist('OCTAVE_VERSION'))
%     more off %this seems necessary in order to get back the screen in Octave, but we have not tested this script on Octave yet.
% end

fprintf('Generating validation set, please wait...\n')
fid=fopen([data_dir 'ALARMS'],'r');
if(fid ~= -1)
    RECLIST=textscan(fid,'%s %s %d','Delimiter',',');
    fclose(fid);
else
    error('Could not open ALARMS.txt for scoring. Exiting...')
end

RECORDS=RECLIST{1};
ALARMS=RECLIST{2};
ALARM_TYPES=unique(ALARMS);
N=length(RECORDS);
results=zeros(N,1);
LABELS = RECLIST{3};

vFFinds = [];
vTinds = [];
vFF_true = [];
vT_false = [];
vT_true = [];
vFF_false = [];
vT_falsePos = [];
vFF_falsePos = [];
Ainds = [];
A_true = [];
A_false = [];
A_falsePos = [];
Binds = [];
B_true = [];
B_false = [];
B_falsePos = [];
Tinds = [];
T_true = [];
T_false = [];
T_falsePos = [];

for kk = 1:N
    if strcmp(ALARMS{kk},ALARM_TYPES{4})
        vFFinds = [vFFinds,kk];
        vT_false = [vT_false , kk];
        A_false = [A_false , kk];
        B_false = [B_false , kk];
        T_false = [T_false , kk];
        if LABELS(kk)
            vFF_true = [vFF_true , kk];
        else
            vFF_false = [vFF_false , kk];
            vFF_falsePos = [vFF_falsePos,kk];
        end
    elseif strcmp(ALARMS{kk},ALARM_TYPES{5})
        vTinds = [vTinds,kk];
        vFF_false = [vFF_false , kk];
        A_false = [A_false , kk];
        B_false = [B_false , kk];
        T_false = [T_false , kk];
        if LABELS(kk)
            vT_true = [vT_true , kk];
        else
            vT_false = [vT_false , kk];
            vT_falsePos = [vT_falsePos ,kk];
        end
    elseif strcmp(ALARMS{kk},ALARM_TYPES{1})
        Ainds = [Ainds,kk];
        vT_false = [vT_false , kk];
        vFF_false = [vFF_false , kk];
        T_false = [T_false , kk];
        B_false = [B_false , kk];
        if LABELS(kk)
            A_true = [A_true , kk];
        else
            A_false = [A_false , kk];
            A_falsePos = [A_falsePos ,kk];
        end
    elseif strcmp(ALARMS{kk},ALARM_TYPES{2})
        Binds = [Binds,kk];
        vT_false = [vT_false , kk];
        vFF_false = [vFF_false , kk];
        A_false = [A_false , kk];
        T_false = [T_false , kk];
        if LABELS(kk)
            B_true = [A_true , kk];
        else
            B_false = [B_false , kk];
            B_falsePos = [B_falsePos ,kk];
        end
    elseif strcmp(ALARMS{kk},ALARM_TYPES{3})
        Tinds = [Tinds,kk];
        vT_false = [vT_false , kk];
        vFF_false = [vFF_false , kk];
        A_false = [A_false , kk];
        B_false = [B_false , kk];
        if LABELS(kk)
            T_true = [T_true , kk];
        else
            T_false = [T_false , kk];
            T_falsePos = [T_falsePos ,kk];
        end
    else
        vFF_false = [vFF_false , kk];
        vT_false = [vT_false , kk];
        A_false = [A_false, kk];
        B_false = [B_false , kk];
        T_false = [T_false , kk];
    end
end

trainConvs = cell(N,1);
trainLogPows = cell(N,1);
%%


for kk = 1:N
    [~,~,trainConvs{kk},trainVals{kk}] = challenge([data_dir RECORDS{kk}],ALARMS{kk});
    
end
%%
crap = [];
for kk = 1:750
if isinf(trainVals{kk})
    crap = [crap , kk];
elseif isempty(trainVals{kk})
    crap = [crap,kk];
end
end


[~,crapInd,~] = intersect(vFF_false,crap);
vFF_false(crapInd) = [];
[~,crapInd,~] = intersect(vFF_true,crap);
vFF_true(crapInd) = [];
[~,crapInd,~] = intersect(vT_false,crap);
vT_false(crapInd) = [];
[~,crapInd,~] = intersect(vT_true,crap);
vT_true(crapInd) = [];
[~,crapInd,~] = intersect(vFF_falsePos,crap);
vFF_falsePos(crapInd) = [];
[~,crapInd,~] = intersect(vT_falsePos,crap);
vT_falsePos(crapInd) = [];

[~,crapInd,~] = intersect(A_false,crap);
A_false(crapInd) = [];
[~,crapInd,~] = intersect(A_true,crap);
A_true(crapInd) = [];
[~,crapInd,~] = intersect(A_falsePos,crap);
A_falsePos(crapInd) = [];

[~,crapInd,~] = intersect(B_false,crap);
B_false(crapInd) = [];
[~,crapInd,~] = intersect(B_true,crap);
B_true(crapInd) = [];
[~,crapInd,~] = intersect(B_falsePos,crap);
B_falsePos(crapInd) = [];

[~,crapInd,~] = intersect(T_false,crap);
T_false(crapInd) = [];
[~,crapInd,~] = intersect(T_true,crap);
T_true(crapInd) = [];
[~,crapInd,~] = intersect(T_falsePos,crap);
T_falsePos(crapInd) = [];

%% LDA analysis

% trTr = [1:65];
% teTr = [65:89];
% trFa = [1:65];
% teFa = [66:245];

% trTr = [30:89];
% teTr = [1:29];
% trFa = [70:129];
% teFa = [1:69,130:245];

trTr = [1:88,1:88,1:65];
teTr = [1:88];
trFa = [1:240];
teFa = [1:240];

% trTr = [1:60,1:60,1:60];
% teTr = [61:88];
% trFa = [1:180];
% teFa = [181:240];

% PCA:
trainerVT = [];
labelsTrainVT = [];
count = 1;
for ii = vT_falsePos(trFa)
    temp = trainVals{ii};
    trainerVT(:,count) = temp(:)';
    count = count+1;
end
labelsTrainVT = -ones(length(trFa),1);
% labelsTrainVT = 0*labelsTrainVT; % for lda
for ii = vT_true(trTr)
    temp = trainVals{ii};
    trainerVT(:,count) = temp(:)';
    count = count+1;
end
labelsTrainVT = [labelsTrainVT;ones(length(trTr),1)];
trainerVT = trainerVT';
% trainerVT = bsxfun(@minus,trainerVT,mean(trainerVT));

testerVT = [];
labelsTestVT = [];
count = 1;
for ii = vT_falsePos(teFa)
    temp = trainVals{ii};
    testerVT(:,count) = temp(:)';
    count = count+1;
end
labelsTestVT = -ones(length(teFa),1);
% labelsTestVT = 0*labelsTestVT; % for lda
for ii = vT_true(teTr)
    temp = trainVals{ii};
    testerVT(:,count) = temp(:)';
    count = count+1;
end
labelsTestVT = [labelsTestVT;ones(length(teTr),1)];
testerVT = testerVT';

ambientVT = [];
labelsAmbientVT = [];
count = 1;
for ii = 1:length(vT_false)
    if isempty(intersect(vT_false(ii),vT_falsePos))
        temp = trainVals{vT_false(ii)};
        ambientVT(:,count) = temp(:)';
        count=count+1;
    end
end
ambientVT = ambientVT';
labelsAmbientVT = zeros(count-1,1);
% cut off some freqencies?
testerVT = testerVT(:,1:50);
trainerVT = trainerVT(:,1:50);
ambientVT = ambientVT(:,1:50);

% zero mean?
testerVT = bsxfun(@minus,testerVT,mean(testerVT));
trainerVT = bsxfun(@minus,trainerVT,mean(trainerVT));
ambientVT = bsxfun(@minus,ambientVT,mean(ambientVT));
%% LDA


[coeff,~,~,~,explained,~] = pca([trainerVT;testerVT]);
% testIt = zeros(600,1);
% for ii = 1:581
learnedPCA = coeff(:,1:30);
% learnedPCA = coeff(:,[1,2,4,6:17,19,20]);
% learnedPCA = coeff(:,[2,7,9,12:20,23,24,33,34,35]);
% learnedPCA = coeff(:,1:129);
trainerVTpca = trainerVT*learnedPCA;
testerVTpca = testerVT*learnedPCA;
ambientVTpca = ambientVT*learnedPCA;
% W = LDA(trainerVFpca,labelsVF);
% LDAscores = [ones(length(labelsVF),1) trainerVFpca] * W';
% LDAprobs = exp(LDAscores) ./ repmat(sum(exp(LDAscores),2),[1 2]);
% tester = LDAprobs(:,2) >= LDAprobs(:,1);
% testIt(ii) = sum(tester == labelsVF)/728;
% figure; plot(LDAprobs)
% end

% temp = trainerVTpca;
% trainerVTpca = testerVTpca;
% testerVTpca = temp;
% temp = labelsTrainVT;
% labelsTrainVT = labelsTestVT;
% labelsTestVT = temp;

% LDA..
W = LDA(trainerVTpca,labelsTrainVT);
testScore = [ones(size(testerVTpca,1),1) testerVTpca] * W';
testProbs = exp(testScore) ./ repmat(sum(exp(testScore),2),[1 2]);
testLabels = (testProbs(:,1)<testProbs(:,2));
% testLabels = zeros(length(labelsTestVT),1);
% for ii = 1:length(labelsTestVT)
%     testLabels(ii) = vt_classifier(testerVT(ii,:));
% end
truePosits = length( find( (testLabels & labelsTestVT) == 1))/length( find( labelsTestVT == 1));
falsePosits = length( find( (testLabels & ~labelsTestVT) == 1))/length( find( labelsTestVT == 0));
trueNegits = length( find( (~testLabels & ~labelsTestVT) == 1))/length( find( labelsTestVT == 0));
falseNegits = length( find( (~testLabels & labelsTestVT) == 1))/length( find( labelsTestVT == 1));
errRates = [truePosits , falsePosits ; falseNegits , trueNegits];

%% MR learning


[coeff,~,~,~,explained,~] = pca([trainerVT;testerVT]);
% testIt = zeros(600,1);
% for ii = 1:581
learnedPCA = coeff(:,1:50);
% learnedPCA = eye(50);
% learnedPCA = coeff(:,[1,2,4,6:17,19,20]);
% learnedPCA = coeff(:,[2,7,9,12:20,23,24,33,34,35]);
% learnedPCA = coeff(:,1:129);
trainerVTpca = trainerVT*learnedPCA;
testerVTpca = testerVT*learnedPCA;
ambientVTpca = ambientVT*learnedPCA;
% W = LDA(trainerVFpca,labelsVF);
% LDAscores = [ones(length(labelsVF),1) trainerVFpca] * W';
% LDAprobs = exp(LDAscores) ./ repmat(sum(exp(LDAscores),2),[1 2]);
% tester = LDAprobs(:,2) >= LDAprobs(:,1);
% testIt(ii) = sum(tester == labelsVF)/728;
% figure; plot(LDAprobs)
% end

% MR...

% good vals so far:
% options = ml_options('Kernel','rbf','KernelParam',5e4,'gamma_A',1e0,'gamma_I',1e0);
% options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',1e0,'gamma_I',1e0);
% NO False Negatives (above)
% options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',2e-2,'gamma_I',5e-3);

% options = ml_options('Kernel','rbf','KernelParam',9.933,'gamma_A',1e0,'gamma_I',0);
options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',1e0,'gamma_I',1.1e-1);
classifier = ml_train([trainerVTpca;ambientVTpca],[labelsTrainVT;labelsAmbientVT],options,'laprlsc');
[classed,testLabels,error] = ml_test(classifier,testerVTpca,labelsTestVT);

testLabels1 = testLabels;
labelsTestVT1 = labelsTestVT;
testLabels1 = testLabels == 1;
labelsTestVT1 = labelsTestVT == 1;

truePosits = length( find( (testLabels1 & labelsTestVT1) == 1))/length( find( labelsTestVT1 == 1));
falsePosits = length( find( (testLabels1 & ~labelsTestVT1) == 1))/length( find( labelsTestVT1 == 0));
trueNegits = length( find( (~testLabels1 & ~labelsTestVT1) == 1))/length( find( labelsTestVT1 == 0));
falseNegits = length( find( (~testLabels1 & labelsTestVT1) == 1))/length( find( labelsTestVT1 == 1));
errRates1 = [truePosits , falsePosits ; falseNegits , trueNegits];

parameters.alpha = classifier.alpha;
parameters.xtrain = classifier.xtrain;
parameters.learnedPCA = learnedPCA;
    


%% LDA analysis

% trTr = [1:65];
% teTr = [65:89];
% trFa = [1:65];
% teFa = [66:245];
% trTr = [1:6,1:6,1:6,1:6,1:6,1:6,1:6,1:6,1:3];
% trTr = [1:4,1:4,1:4,1:4,1:4,1:4,1:4,1:4];
% trTr = [1:5];
% teTr = [5:6];
% trFa = [1:32];
% teFa = [33:51];

trTr = [repmat([1:4],1,12),1:2];
teTr = [1:4];
trFa = [1:50];
teFa = [1:50];

% PCA:
trainerVFF = [];
labelsTrainVFF = [];
count = 1;
for ii = vFF_falsePos(trFa)
    temp = trainVals{ii};
    trainerVFF(:,count) = temp(:)';
    count = count+1;
end
labelsTrainVFF = -ones(length(trFa),1);
% labelsTrainVFF = 0*labelsTrainVFF; % for lda
for ii = vFF_true(trTr)
    temp = trainVals{ii};
    trainerVFF(:,count) = temp(:)';
    count = count+1;
end
labelsTrainVFF = [labelsTrainVFF;ones(length(trTr),1)];
trainerVFF = trainerVFF';
% trainerVFF = bsxfun(@minus,trainerVT,mean(trainerVT));

testerVFF = [];
labelsTestVFF = [];
count = 1;
for ii = vFF_falsePos(teFa)
    temp = trainVals{ii};
    testerVFF(:,count) = temp(:)';
    count = count+1;
end
labelsTestVFF = -ones(length(teFa),1);
% labelsTestVFF = 0*labelsTestVFF; % for lda
for ii = vFF_true(teTr)
    temp = trainVals{ii};
    testerVFF(:,count) = temp(:)';
    count = count+1;
end
labelsTestVFF = [labelsTestVFF;ones(length(teTr),1)];
testerVFF = testerVFF';

ambientVFF = [];
labelsAmbientVFF = [];
count = 1;
for ii = 1:length(vFF_false)
    if isempty(intersect(vFF_false(ii),vFF_falsePos))
        temp = trainVals{vFF_false(ii)};
        ambientVFF(:,count) = temp(:)';
        count=count+1;
    end
end
ambientVFF = ambientVFF';
labelsAmbientVFF = zeros(count-1,1);
% cut off some freqencies?
testerVFF = testerVFF(:,1:50);
trainerVFF = trainerVFF(:,1:50);
ambientVFF = ambientVFF(:,1:50);

% add some noise?
trainerVFF = trainerVFF + bsxfun(@times,randn(size(trainerVFF)),.05*var(trainerVFF));

% zero mean?
testerVFF = bsxfun(@minus,testerVFF,mean(testerVFF));
trainerVFF = bsxfun(@minus,trainerVFF,mean(trainerVFF));
ambientVFF = bsxfun(@minus,ambientVFF,mean(ambientVFF));

% trainerVFF(52:end,:) = trainerVFF(52:end,:) + (bsxfun(@times,randn(size(trainerVFF(52:end,:))),.25*var(trainerVFF(52:end,:))));
%% LDA


[coeff,~,~,~,explained,~] = pca([trainerVFF;testerVFF]);
% testIt = zeros(600,1);
% for ii = 1:581
learnedPCA = coeff(:,1:10);
% learnedPCA = coeff(:,[1,2,4,6:17,19,20]);
% learnedPCA = coeff(:,[2,7,9,12:20,23,24,33,34,35]);
% learnedPCA = coeff(:,1:129);
trainerVFFpca = trainerVFF*learnedPCA;
testerVFFpca = testerVFF*learnedPCA;
ambientVFFpca = ambientVFF*learnedPCA;
% W = LDA(trainerVFpca,labelsVF);
% LDAscores = [ones(length(labelsVF),1) trainerVFpca] * W';
% LDAprobs = exp(LDAscores) ./ repmat(sum(exp(LDAscores),2),[1 2]);
% tester = LDAprobs(:,2) >= LDAprobs(:,1);
% testIt(ii) = sum(tester == labelsVF)/728;
% figure; plot(LDAprobs)
% end

% temp = trainerVTpca;
% trainerVTpca = testerVTpca;
% testerVTpca = temp;
% temp = labelsTrainVT;
% labelsTrainVT = labelsTestVT;
% labelsTestVT = temp;

% LDA..
W = LDA(trainerVFFpca,labelsTrainVFF);
testScore = [ones(size(testerVFFpca,1),1) testerVFFpca] * W';
testProbs = exp(testScore) ./ repmat(sum(exp(testScore),2),[1 2]);
testLabels = (testProbs(:,1)<testProbs(:,2));
truePosits = length( find( (testLabels & labelsTestVFF) == 1))/length( find( labelsTestVFF == 1));
falsePosits = length( find( (testLabels & ~labelsTestVFF) == 1))/length( find( labelsTestVFF == 0));
trueNegits = length( find( (~testLabels & ~labelsTestVFF) == 1))/length( find( labelsTestVFF == 0));
falseNegits = length( find( (~testLabels & labelsTestVFF) == 1))/length( find( labelsTestVFF == 1));
errRates = [truePosits , falsePosits ; falseNegits , trueNegits];



%% MR learning


[coeff,~,~,~,explained,~] = pca([trainerVFF;testerVFF]);
% testIt = zeros(600,1);
% for ii = 1:581
learnedPCA = coeff(:,1:30);
% learnedPCA = coeff(:,[1,2,4,6:17,19,20]);
% learnedPCA = coeff(:,[2,7,9,12:20,23,24,33,34,35]);
% learnedPCA = coeff(:,1:129);
trainerVFFpca = trainerVFF*learnedPCA;
testerVFFpca = testerVFF*learnedPCA;
ambientVFFpca = ambientVFF*learnedPCA;
% W = LDA(trainerVFpca,labelsVF);
% LDAscores = [ones(length(labelsVF),1) trainerVFpca] * W';
% LDAprobs = exp(LDAscores) ./ repmat(sum(exp(LDAscores),2),[1 2]);
% tester = LDAprobs(:,2) >= LDAprobs(:,1);
% testIt(ii) = sum(tester == labelsVF)/728;
% figure; plot(LDAprobs)
% end

% MR...

% good vals so far:
% options = ml_options('Kernel','rbf','KernelParam',5e4,'gamma_A',1e0,'gamma_I',1e0);
% options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',1e0,'gamma_I',1e0);
% NO False Negatives (above)
% options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',2e-2,'gamma_I',5e-3);
% options = ml_options('Kernel','rbf','KernelParam',1.2e1,'gamma_A',1e-1,'gamma_I',1.5e0);
% options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',1e-2,'gamma_I',1e2);
% options = ml_options('Kernel','poly','KernelParam',3,'gamma_A',1e-1,'gamma_I',1e2);

options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',1e0,'gamma_I',1.1e-1);
% options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',1e1,'gamma_I',3e2);
% options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',3e-2,'gamma_I',1e2);
classifier = ml_train([trainerVFFpca;ambientVFFpca],[labelsTrainVFF;labelsAmbientVFF],options,'laprlsc');
[classed,testLabels,error] = ml_test(classifier,testerVFFpca,labelsTestVFF);

testLabels1 = (testLabels == 1);
labelsTestVFF1 = (labelsTestVFF == 1);

truePosits = length( find( (testLabels1 & labelsTestVFF1) == 1))/length( find( labelsTestVFF1 == 1));
falsePosits = length( find( (testLabels1 & ~labelsTestVFF1) == 1))/length( find( labelsTestVFF1 == 0));
trueNegits = length( find( (~testLabels1 & ~labelsTestVFF1) == 1))/length( find( labelsTestVFF1 == 0));
falseNegits = length( find( (~testLabels1 & labelsTestVFF1) == 1))/length( find( labelsTestVFF1 == 1));
errRates1 = [truePosits , falsePosits ; falseNegits , trueNegits];

parameters.alpha = classifier.alpha;
parameters.xtrain = classifier.xtrain;
parameters.learnedPCA = learnedPCA;


%% Cross Validate VT:
foo = randperm(88,88);
bar = randperm(240,240);
% trueInds = [1:22;23:44;45:66;67:88];
% falsInds = [1:60;61:120;121:180;181:240];
trueInds = [foo(1:22);foo(23:44);foo(45:66);foo(67:88)];
falsInds = [bar(1:60);bar(61:120);bar(121:180);bar(181:240)];
errRates = [];

% 4 fold cross validate.
for mm = 1:4
trTr = repmat([trueInds(mod(mm+1,4)+1,:),trueInds(mod(mm+2,4)+1,:),trueInds(mod(mm+3,4)+1,:)],1,5);
trTr = trTr(1:180);
teTr = trueInds(mod(mm,4)+1,:);
trFa = [falsInds(mod(mm+1,4)+1,:),falsInds(mod(mm+2,4)+1,:),falsInds(mod(mm+3,4)+1,:)];
teFa = falsInds(mod(mm,4)+1,:);
trainerVT = [];
labelsTrainVT = [];
count = 1;
for ii = vT_falsePos(trFa)
    temp = trainVals{ii};
    trainerVT(:,count) = temp(:)';
    count = count+1;
end
labelsTrainVT = -ones(length(trFa),1);
% labelsTrainVT = 0*labelsTrainVT; % for lda
for ii = vT_true(trTr)
    temp = trainVals{ii};
    trainerVT(:,count) = temp(:)';
    count = count+1;
end
labelsTrainVT = [labelsTrainVT;ones(length(trTr),1)];
trainerVT = trainerVT';
% trainerVT = bsxfun(@minus,trainerVT,mean(trainerVT));

testerVT = [];
labelsTestVT = [];
count = 1;
for ii = vT_falsePos(teFa)
    temp = trainVals{ii};
    testerVT(:,count) = temp(:)';
    count = count+1;
end
labelsTestVT = -ones(length(teFa),1);
% labelsTestVT = 0*labelsTestVT; % for lda
for ii = vT_true(teTr)
    temp = trainVals{ii};
    testerVT(:,count) = temp(:)';
    count = count+1;
end
labelsTestVT = [labelsTestVT;ones(length(teTr),1)];
testerVT = testerVT';

ambientVT = [];
labelsAmbientVT = [];
count = 1;
for ii = 1:length(vT_false)
    if isempty(intersect(vT_false(ii),vT_falsePos))
        temp = trainVals{vT_false(ii)};
        ambientVT(:,count) = temp(:)';
        count=count+1;
    end
end
ambientVT = ambientVT';
labelsAmbientVT = zeros(count-1,1);
% cut off some freqencies?
testerVT = testerVT(:,1:50);
trainerVT = trainerVT(:,1:50);
ambientVT = ambientVT(:,1:50);

% zero mean?
testerVT = bsxfun(@minus,testerVT,mean(testerVT));
trainerVT = bsxfun(@minus,trainerVT,mean(trainerVT));
ambientVT = bsxfun(@minus,ambientVT,mean(ambientVT));


[coeff,~,~,~,explained,~] = pca([trainerVT;testerVT]);
% testIt = zeros(600,1);
% for ii = 1:581
learnedPCA = coeff(:,1:50);
% learnedPCA = eye(50);
% learnedPCA = coeff(:,[1,2,4,6:17,19,20]);
% learnedPCA = coeff(:,[2,7,9,12:20,23,24,33,34,35]);
% learnedPCA = coeff(:,1:129);
trainerVTpca = trainerVT*learnedPCA;
testerVTpca = testerVT*learnedPCA;
ambientVTpca = ambientVT*learnedPCA;
% W = LDA(trainerVFpca,labelsVF);
% LDAscores = [ones(length(labelsVF),1) trainerVFpca] * W';
% LDAprobs = exp(LDAscores) ./ repmat(sum(exp(LDAscores),2),[1 2]);
% tester = LDAprobs(:,2) >= LDAprobs(:,1);
% testIt(ii) = sum(tester == labelsVF)/728;
% figure; plot(LDAprobs)
% end

% MR...

% good vals so far:
% options = ml_options('Kernel','rbf','KernelParam',5e4,'gamma_A',1e0,'gamma_I',1e0);
% options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',1e0,'gamma_I',1e0);
% NO False Negatives (above)
% options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',2e-2,'gamma_I',5e-3);

% options = ml_options('Kernel','rbf','KernelParam',9.933,'gamma_A',1e0,'gamma_I',0);
options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',1e0,'gamma_I',1.1e-1);
classifier = ml_train([trainerVTpca;ambientVTpca],[labelsTrainVT;labelsAmbientVT],options,'laprlsc');
[classed,testLabels,error] = ml_test(classifier,testerVTpca,labelsTestVT);

testLabels1 = testLabels;
labelsTestVT1 = labelsTestVT;
testLabels1 = testLabels == 1;
labelsTestVT1 = labelsTestVT == 1;

truePosits = length( find( (testLabels1 & labelsTestVT1) == 1))/length( find( labelsTestVT1 == 1));
falsePosits = length( find( (testLabels1 & ~labelsTestVT1) == 1))/length( find( labelsTestVT1 == 0));
trueNegits = length( find( (~testLabels1 & ~labelsTestVT1) == 1))/length( find( labelsTestVT1 == 0));
falseNegits = length( find( (~testLabels1 & labelsTestVT1) == 1))/length( find( labelsTestVT1 == 1));
errRates(:,:,mm) = [truePosits , falsePosits ; falseNegits , trueNegits];
% parameters.alpha = classifier.alpha;
% parameters.xtrain = classifier.xtrain;
% parameters.learnedPCA = learnedPCA;
    

end

cnt = cnt+1;
collect(:,:,cnt) = mean(errRates,3);

%% 4-fold cross-validate Asystole
foo = randperm(17,17);
bar = randperm(93,93);
% trueInds = [1:22;23:44;45:66;67:88];
% falsInds = [1:60;61:120;121:180;181:240];
trueInds = [foo(1:4);foo(5:8);foo(9:12);foo(13:16)];
falsInds = [bar(1:23);bar(24:46);bar(47:69);bar(70:92)];
errRates = [];

% 4 fold cross validate.
for mm = 1:4
trTr = repmat([trueInds(mod(mm+1,4)+1,:),trueInds(mod(mm+2,4)+1,:),trueInds(mod(mm+3,4)+1,:)],1,6);
% trTr = trTr(1:180);
teTr = trueInds(mod(mm,4)+1,:);
trFa = [falsInds(mod(mm+1,4)+1,:),falsInds(mod(mm+2,4)+1,:),falsInds(mod(mm+3,4)+1,:)];
teFa = falsInds(mod(mm,4)+1,:);
trainer = [];
labelsTrain = [];
count = 1;
for ii = A_falsePos(trFa)
    temp = trainVals{ii};
    trainer(:,count) = temp(:)';
    count = count+1;
end
labelsTrain = -ones(length(trFa),1);
% labelsTrain = 0*labelsTrain; % for lda
for ii = A_true(trTr)
    temp = trainVals{ii};
    trainer(:,count) = temp(:)';
    count = count+1;
end
labelsTrain = [labelsTrain;ones(length(trTr),1)];
trainer = trainer';
% trainerVT = bsxfun(@minus,trainerVT,mean(trainerVT));

tester = [];
labelsTest = [];
count = 1;
for ii = A_falsePos(teFa)
    temp = trainVals{ii};
    tester(:,count) = temp(:)';
    count = count+1;
end
labelsTest = -ones(length(teFa),1);
% labelsTestVT = 0*labelsTestVT; % for lda
for ii = A_true(teTr)
    temp = trainVals{ii};
    tester(:,count) = temp(:)';
    count = count+1;
end
labelsTest = [labelsTest;ones(length(teTr),1)];
tester = tester';

ambient = [];
labelsAmbient = [];
count = 1;
for ii = 1:length(A_false)
    if isempty(intersect(A_false(ii),A_falsePos))
        temp = trainVals{A_false(ii)};
        ambient(:,count) = temp(:)';
        count=count+1;
    end
end
ambient = ambient';
labelsAmbient = zeros(count-1,1);
% cut off some freqencies?
tester = tester(:,1:50);
trainer = trainer(:,1:50);
ambient = ambient(:,1:50);

% zero mean?
tester = bsxfun(@minus,tester,mean(tester));
trainer = bsxfun(@minus,trainer,mean(trainer));
ambient = bsxfun(@minus,ambient,mean(ambient));


[coeff,~,~,~,explained,~] = pca([trainer;tester]);
% testIt = zeros(600,1);
% for ii = 1:581
learnedPCA = coeff(:,1:50);
% learnedPCA = eye(50);
% learnedPCA = coeff(:,[1,2,4,6:17,19,20]);
% learnedPCA = coeff(:,[2,7,9,12:20,23,24,33,34,35]);
% learnedPCA = coeff(:,1:129);
trainerpca = trainer*learnedPCA;
testerpca = tester*learnedPCA;
ambientpca = ambient*learnedPCA;
% W = LDA(trainerVFpca,labelsVF);
% LDAscores = [ones(length(labelsVF),1) trainerVFpca] * W';
% LDAprobs = exp(LDAscores) ./ repmat(sum(exp(LDAscores),2),[1 2]);
% tester = LDAprobs(:,2) >= LDAprobs(:,1);
% testIt(ii) = sum(tester == labelsVF)/728;
% figure; plot(LDAprobs)
% end

% MR...

% good vals so far:
% options = ml_options('Kernel','rbf','KernelParam',5e4,'gamma_A',1e0,'gamma_I',1e0);
% options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',1e0,'gamma_I',1e0);
% NO False Negatives (above)
% options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',2e-2,'gamma_I',5e-3);

% options = ml_options('Kernel','rbf','KernelParam',9.933,'gamma_A',1e0,'gamma_I',0);
options = ml_options('Kernel','linear','KernelParam',1,'gamma_A',1e0,'gamma_I',1e1);
classifier = ml_train([trainerpca;ambientpca],[labelsTrain;labelsAmbient],options,'laprlsc');
[classed,testLabels,error] = ml_test(classifier,testerpca,labelsTest);

testLabels1 = testLabels;
labelsTest1 = labelsTest;
testLabels1 = testLabels == 1;
labelsTest1 = labelsTest == 1;

truePosits = length( find( (testLabels1 & labelsTest1) == 1))/length( find( labelsTest1 == 1));
falsePosits = length( find( (testLabels1 & ~labelsTest1) == 1))/length( find( labelsTest1 == 0));
trueNegits = length( find( (~testLabels1 & ~labelsTest1) == 1))/length( find( labelsTest1 == 0));
falseNegits = length( find( (~testLabels1 & labelsTest1) == 1))/length( find( labelsTest1 == 1));
errRates(:,:,mm) = [truePosits , falsePosits ; falseNegits , trueNegits];
% parameters.alpha = classifier.alpha;
% parameters.xtrain = classifier.xtrain;
% parameters.learnedPCA = learnedPCA;
    

end

cnt = cnt+1;
collect(:,:,cnt) = mean(errRates,3);