data_dir = 'C:\Users\Kenneth_2\Documents\MATLAB\PhysNet2015\training\';
fprintf('Generating validation set, please wait...\n')
fid=fopen([data_dir 'ALARMS'],'r');
if(fid ~= -1)
RECLIST=textscan(fid,'%s %s %d','Delimiter',',');
fclose(fid);
else
error('Could not open ALARMS.txt for scoring. Exiting...')
end
RECORDS=RECLIST{1};
ALARMS=RECLIST{2};
LABELS = RECLIST{3};
N=length(RECORDS);
results=zeros(N,1); 
%%
for jj = 1:5
    data{jj,1}.preBeats = [];
    data{jj,1}.postBeatsT = [];
    data{jj,1}.postBeatsF = [];
    data{jj,2}.preBeats = [];
    data{jj,2}.postBeatsT = [];
    data{jj,2}.postBeatsF = [];
end

for ii = 1:N
    clear foo
    [~,foo{1},foo{2}] = challenge1([data_dir RECORDS{ii}],ALARMS{ii});
    gob = [];
    if ~isempty(foo{1});
        gob = [gob,1];
    end
    if ~isempty(foo{2});
        gob = [gob,2];
    end
    for jj = gob
        switch ALARMS{ii}
            case 'Asystole'
                type = 1;
            case 'Bradycardia'
                type = 2;
            case 'Tachycardia'
                type = 3;
            case 'Ventricular_Tachycardia'
                type = 4;
            case 'Ventricular_Flutter_Fib'
                type = 5;
        end
        if LABELS(ii)
            bar = [];
            for kk = 1:size(foo{jj}.preSCV,3)
                bar = cat(2,bar,nonzeros(triu(logm(squeeze(foo{jj}.preSCV(:,:,kk))))));
            end
            data{type,jj}.preBeats = cat(2,data{type,jj}.preBeats,bar);
            bar = [];
            for kk = 1:size(foo{jj}.postSCV,3)
                bar = cat(2,bar,nonzeros(triu(logm(squeeze(foo{jj}.postSCV(:,:,kk))))));
            end
            data{type,jj}.postBeatsT = cat(2,data{type,jj}.postBeatsT , bar);
        else
            bar = [];
            for kk = 1:size(foo{jj}.preSCV,3)
                bar = cat(2,bar,nonzeros(triu(logm(squeeze(foo{jj}.preSCV(:,:,kk))))));
            end
            data{type,jj}.preBeats = cat(2,data{type,jj}.preBeats , bar);
            bar = [];
            for kk = 1:size(foo{jj}.postSCV,3)
                bar = cat(2,bar,nonzeros(triu(logm(squeeze(foo{jj}.postSCV(:,:,kk))))));
            end
            data{type,jj}.postBeatsF = cat(2,data{type,jj}.postBeatsF , bar); 
        end
%         if LABELS(ii)
%             data{tp,jj}.preBeats = cat(3,data{tp,jj}.preBeats , foo{jj}.preSCV); 
%             data{tp,jj}.postBeats = cat(3,data{tp,jj}.postBeats , foo{jj}.postSCV);
%         else % If this was a false positive, let's put the post-beats in the pre-beats class. 
%             data{tp,jj}.preBeats = cat(3,data{tp,jj}.preBeats , foo{jj}.preSCV);
%             data{tp,jj}.preBeats = cat(3,data{tp,jj}.preBeats , foo{jj}.postSCV); 
%         end
    end
            
end

%% Clean it
for ii = 1:5
    for jj = 1:2
        foo = data{ii,jj};
        removal = [];
        for kk = 1:size(foo.preBeats,2)
            if find(isnan(foo.preBeats(:,kk))==1)
                removal = cat(1,removal,kk);
            end
        end
        foo.preBeats = real(foo.preBeats(:,setdiff(1:kk,removal)));
        removal = [];
        for kk = 1:size(foo.postBeatsT,2)
            if find(isnan(foo.postBeatsT(:,kk))==1)
                removal = cat(1,removal,kk);
            end
        end
        foo.postBeatsT = real(foo.postBeatsT(:,setdiff(1:kk,removal)));
        removal = [];
        for kk = 1:size(foo.postBeatsF,2)
            if find(isnan(foo.postBeatsF(:,kk))==1)
                removal = cat(1,removal,kk);
            end
        end
        foo.postBeatsF = real(foo.postBeatsF(:,setdiff(1:kk,removal)));
        
        data{ii,jj} = foo;
    end
end
%% Train it!
event = 5; type = 2;
setCount(1) = size(data{event,type}.postBeatsF,2);
setCount(2) = size(data{event,type}.postBeatsT,2);

ambientData = data{event,type}.preBeats;
if size(ambientData,2)>9000
    ambientData = ambientData(:,randperm(size(ambientData,2),9000));
end
trainData = cat(2,data{event,type}.postBeatsF,data{event,type}.postBeatsT);
trainLabel = cat(2,zeros(setCount(1),1)',ones(setCount(2),1)');

% 2 way cross validation sets:
pI{1}.i = randperm(setCount(1));
pI{2}.i = randperm(setCount(2))+setCount(1);

cV{1} = cat(2,pI{1}.i(1:floor(setCount(1)/2)),pI{2}.i(1:floor(setCount(2)/2))); 
cV{2} = cat(2,pI{1}.i((floor(setCount(1)/2)+1):end),pI{2}.i((floor(setCount(2)/2)+1):end)); 

% a set is now: trainData(:,cV{1}) and trainLabel(cV{1});

%% LDA
for ii = 1:2
    a = 1+mod(ii,2);
    b = 1+mod(ii+1,2);
    W = LDA(trainData(:,cV{a})',trainLabel(cV{a}));
    testScore = [ones(1,length(cV{b})) ; trainData(:,cV{b})]' * W';
    testProbs = exp(testScore) ./ repmat(sum(exp(testScore),2),[1 2]);
    testLabels = (testProbs(:,1)<testProbs(:,2));

    truePosits(ii) = length( find( (testLabels & trainLabel(cV{b})') == 1))/length( find( trainLabel(cV{b})' == 1));
    falsePosits(ii) = length( find( (testLabels & ~trainLabel(cV{b})') == 1))/length( find( trainLabel(cV{b})' == 0));
    trueNegits(ii) = length( find( (~testLabels & ~trainLabel(cV{b})') == 1))/length( find( trainLabel(cV{b})' == 0));
    falseNegits(ii) = length( find( (~testLabels & trainLabel(cV{b})') == 1))/length( find( trainLabel(cV{b})' == 1));
    errRates{ii} = [truePosits(ii) , falsePosits(ii) ; falseNegits(ii) , trueNegits(ii)];
end


%% MR
for ii = 1:2
    a = 1+mod(ii,2);
    b = 1+mod(ii+1,2);
    options = ml_options('Kernel','rbf','KernelParam',1,'gamma_A',1e0,'gamma_I',1e0);
    classifier = ml_train([trainData(:,cV{a})';ambientData'],[2*trainLabel(cV{a})-1,zeros(size(ambientData,2),1)']',options,'laprlsc');
    [classed,testLabels,error] = ml_test(classifier,trainData(:,cV{b})',2*trainLabel(cV{b})'-1);
    testLabels = (testLabels+1)/2;
    
    truePosits(ii) = length( find( (testLabels & trainLabel(cV{b})') == 1))/length( find( trainLabel(cV{b})' == 1));
    falsePosits(ii) = length( find( (testLabels & ~trainLabel(cV{b})') == 1))/length( find( trainLabel(cV{b})' == 0));
    trueNegits(ii) = length( find( (~testLabels & ~trainLabel(cV{b})') == 1))/length( find( trainLabel(cV{b})' == 0));
    falseNegits(ii) = length( find( (~testLabels & trainLabel(cV{b})') == 1))/length( find( trainLabel(cV{b})' == 1));
    errRates1{ii} = [truePosits(ii) , falsePosits(ii) ; falseNegits(ii) , trueNegits(ii)];
end

%% Train full set and build classifier data structure:
kernelType = 'rbf';
kernelParam = 1;
options = ml_options('Kernel',kernelType,'KernelParam',kernelParam,'gamma_A',1e0,'gamma_I',1e0);
classifier = ml_train([trainData';ambientData'],[2*trainLabel-1,zeros(size(ambientData,2),1)']',options,'laprlsc');
[classed,testLabels,error] = ml_test(classifier,trainData',2*trainLabel'-1);
testLabels = (testLabels+1)/2;

truePosits = length( find( (testLabels & trainLabel') == 1))/length( find( trainLabel' == 1));
falsePosits = length( find( (testLabels & ~trainLabel') == 1))/length( find( trainLabel' == 0));
trueNegits = length( find( (~testLabels & ~trainLabel') == 1))/length( find( trainLabel' == 0));
falseNegits = length( find( (~testLabels & trainLabel') == 1))/length( find( trainLabel' == 1));
errRates2 = [truePosits , falsePosits ; falseNegits , trueNegits];

parameters.kernelType = kernelType;
parameters.kernelParameter = kernelParam;
parameters.a = classifier.alpha';
parameters.b = classifier.b;
parameters.trainData = classifier.xtrain';

save_dir = 'C:\Users\Kenneth_2\Documents\MATLAB\PhysNet2015\entry\';
switch type
    case 1
        switch event
            case 1
                fileName = 'Aa_model.mat';
            case 2
                fileName = 'Ba_model.mat';
            case 3
                fileName = 'Ta_model.mat';
            case 4
                fileName = 'VTa_model.mat';
            case 5
                fileName = 'VFFa_model.mat';
        end
    case 2
        switch event
            case 1
                fileName = 'Ap_model.mat';
            case 2
                fileName = 'Bp_model.mat';
            case 3
                fileName = 'Tp_model.mat';
            case 4
                fileName = 'VTp_model.mat';
            case 5
                fileName = 'VFFp_model.mat';
        end
end

save([save_dir fileName],'parameters');